# Git

Git ist nen Versionverknalltütenprogramm was eder brauch oder auch nicht.

## Inhaltsverzeichniss
1. [Start](#start)
2. [Daten hinzufügen und entfernen](#daten-hinzufügen-und-entfernen)
3. [Neue Version an Git geben und überprüfen](#neue-version-an-git-geben-und-überprüfen)
4. [Mit Git Servern arbeiten](#mit-git-servern-arbeiten)
5. [push und pull](#push-und-pull)
6. [Branches](#branches)

## Start:
Ein Repo ist ein Ding wo deine Projektdaten gespeichert sind.

>### Initialisieren deines Repos:
>```
>git init
>```

>### Downloade ein existierenes Repo:
>```
>git clone <url> 
>```
Nun kannst du mit Git arbeiten z.b. Daten Erstellen und bearbeiten

## Daten hinzufügen und entfernen:

>### Füge Daten zum Repo hinzu:
>```
>git add <datei> 
>```
>>Beispiel: 
>>```
>>git add README.md
>>git add .
>>git add ./README.md
>>```

>### Entferne Daten von Repo:
>```
>git rm <datei> 
>```
>>Beispiel: 
>>```
>>git rm README.md
>>git rm .
>>git rm ./README.md
>>```

## Neue Version an Git geben und überprüfen:
>### Commit erstellen:
>```
>git commit <message>
>```
>> eine Message ist Pflicht!

>### Log anschauen
>```
>git log
>```
>> Zeigt dir deine commits an und auch was du geändert hast


>### Status ansehen
>```
>git status
>```
>> Zeigt dir deine Aktuellen Änderungen an und den aktuelen Branch

## Mit Git Servern arbeiten:
>### Füge ein entferntes Repo hinzu:
>```
>git remote add origin <url>
>```
>>- Die adresse muss mit .git enden
>>- origin ist die Bezeichnung des entfernen Repos

>### Entferne ein entferntes Repo :
>```
>git remote rm origin <url>
>```

## push und pull:
>### push ladet den Branch auf den Server:
>```
>git push origin main
>```
>>- origin ist die Beschreibung des Remote Servers
>>- main Ist Der Branch der gepusht werden soll
>>- push(en) = drücken(de)

>### pull ladet den Branch von Server:
>```
>git pull origin main
>```
>>- origin ist die Beschreibung des Remote Servers
>>- main Ist Der Branch der gepusht werden soll
>>- pull(en) = ziehen(de)

## Branches

Branches auch Zweige sind einfach mehrere Arbeitsflächen.

>### Neuen Branch erstellen
>```
>git branch <branch-name>
>```
>>- Erstellt einfach ein Abbild von den aktuellen Branch
>>- Du bist aber immer noch auf den Aktuellen Branch

>### Branch wecheln
>```
>git checkout <branch-name>
>```
>> Nun hast du den Branch gewechselt

>### Branches zusammenführen
>```
>git merge <branch-name>
>```
>>- Nimmt die Änderungen von den angegebenen Branch und Schiebt sie auf den aktuellen Branch
